#include <unistd.h>
#include <termio.h>
#include <stdio.h>

void echo_off(int fd) {
    struct termio buf;
    /* Flags lesen ... */
    if (ioctl(fd, TCGETA, &buf) < 0)
	perror("ioctl"), exit(1);

    /* ECHO nicht gesetzt? => nichts zu tun */
    if ((buf.c_lflag & ECHO) != ECHO)
	return;

    buf.c_lflag &= ~ECHO;	/* ECHO loeschen */
    
    /* Flags setzen ... */
    if (ioctl(fd, TCSETA, &buf) < 0)
	perror("ioctl"), exit(2);
}

void echo_on(int fd) {
    struct termio buf;
    /* Flags lesen ... */
    if (ioctl(fd, TCGETA, &buf) < 0)
	perror("ioctl"), exit(1);

    /* ECHO gesetzt? => nichts zu tun */
    if ((buf.c_lflag & ECHO) == ECHO)
	return;

    buf.c_lflag |= ECHO;	/* ECHO setzen */
    
    /* Flags setzen ... */
    if (ioctl(fd, TCSETA, &buf) < 0)
	perror("ioctl"), exit(2);
}

int main() {
    char buf[128];

    printf("Name: ");
    fgets(buf, 128, stdin);
    buf[strlen(buf)-1] = '\0';	/* Newline entfernen */
    printf("Ihr Name: %s\n", buf);

    printf("Passwort: ");
    echo_off(0);		/* Echo ausschalten */
    fgets(buf, 128, stdin);
    buf[strlen(buf)-1] = '\0';	/* Newline entfernen */
    echo_on(0);			/* ... und Echo wieder einschalten */
    puts("");
    printf("Ihr Passwort: %s\n", buf);

    return 0;
}
